import { PlayerInteractionInterface } from "../../PlayerInteractionInterface";
import { Board } from "../Board";
import { GameState } from "../../dto/GameState";
import { PlayerMove } from "../PlayerMove";
import { Tile } from "../Tile";
import { MatchSessionState } from "../../dto/MatchSessionState";
import { PlayerDto } from "../../dto/PlayerDto";

export interface PlayerInterface {
  id: string;
  name: string;
  score: number;
  hand: Tile[];
  teamedWith: PlayerInterface | null;
  playerInteraction: PlayerInteractionInterface;
  ready: boolean;

  makeMove(gameState: Board): Promise<PlayerMove | null>;
  chooseTile(board: Board): Promise<Tile>;
  pipsCount(): number;
  reset(): void;
  
  sendEvent(event: string, data: any): Promise<void>;
  sendEventWithAck(event: string, data: any): Promise<any>;

  getState(): PlayerDto;
}