import { MatchSession } from "../../game/MatchSession";
import { DbMatchSession } from "./interfaces";

export function matchSessionAdapter(session: MatchSession) : DbMatchSession {
    return {
        id: session.id,
        name: session.name || '',
        creator: session.creator.id,
        players: session.players.map(player => player.id),
        seed: session.seed,
        mode: session.mode,
        pointsToWin: session.pointsToWin,
        maxPlayers: session.maxPlayers,
        numPlayers: session.numPlayers,
        scoreboard: Array.from(session.scoreboard.entries()).map(([player, score]) => ({ player, score })),
        matchWinner: session.matchWinner ? session.matchWinner.id : null,
        state: session.state
    }

}